#include <SFML/Graphics.hpp>
#include "Exercice5.2.h"
#include "Meneur.h"
#include "Suiveu.h"


///////////////////////////////////////////////////////////////////////////
// TrouverPlusProcheMeneur
// But: la fonction trouve le meneur le plus proche de l'oiseau pass en
//      paramtre. Pour ce faire, la fonction doit tester chacun des
//      oiseaux du tableau. Si l'oiseau est un meneur et que l'oiseau
//      n'est pas le mme que l'oiseau courant alors la distance entre
//      les deux oiseaux est calcule. La distance entre deux points 
//      se calcule avec la formule suivante: sqrt( (x1-x2)^2 + (y1-y2)^2 ).
//      La distance minimale ainsi qu'un pointeur vers le meneur sont
//      conservs dans des variables temporaires. Le pointeur vers le meneur
//      le plus proche est retourn.
//      Il est  noter qu'il n'est pas utile de calculer la racine lorsque
//      l'on cherche le minimum. 
//      
// Intrants: OiseauCourant: oiseau dont on veut trouver 
//                          le plus proche meneur
//           tab:  tableau de tous les oiseaux
//           NbOiseaux: taille du tableau
// Extrant:  pointeur vers le meneur le plus proche
///////////////////////////////////////////////////////////////////////////

const COiseau* TrouverPlusProcheMeneur(const COiseau* OiseauCourant, COiseau* Tab[], int NbOiseaux)
{
   int IndexDuPlusProche = -1; // Aucun meneur trouv encore
   double DistanceDuPlusProche = 1000000; // Trs grande distance pour que le premier meneur trouv soit plus proche
   double distance = 0; // Distance du meneur considr

   for (int i = 0; i < NbOiseaux; i++)  // On parcourt le tableau
   {
      if (Tab[i]->JeSuisUnMeneur()) // On ne considre que les meneurs
      {
         distance = pow((double)(OiseauCourant->GetPosX() - Tab[i]->GetPosX()), 2) +
            pow((double)(OiseauCourant->GetPosY() - Tab[i]->GetPosY()), 2); // Selon la formule fournie
         // Pas besoin de la racine carre pour trouver la plus petite...

         if (distance < DistanceDuPlusProche) // Si c'est mieux que ce qu'on a jusqu' prsent...
         {
            IndexDuPlusProche = i; // ...c'est notre nouveau meilleur...
            DistanceDuPlusProche = distance; // ...et on conserve sa distance.
         }
      }
   }

   // Cette ligne permet seulement de compiler le programme principal, mais il vous faudra
   // la modifier lorsque que vous aurez termin l'implmentation de cette fonction.
   //return OiseauCourant; 

   return Tab[IndexDuPlusProche]; // On retourne un pointeur vers le meneur le plus proche trouv
}

int main(int argc, char *argv[])
{

   COiseau* Tab[NbOiseaux];

   RenderWindow Fenetre(VideoMode(Largeur, Hauteur), "Le retour des oiseaux migrateurs");
   Texture FondImg;
   if (!FondImg.loadFromFile("ciel.bmp"))
   {
      return EXIT_FAILURE;
   }
   Sprite Fond(FondImg);

   Texture SuiveuImg;
   if (!SuiveuImg.loadFromFile("Suiveu.png"))
   {
      return EXIT_FAILURE;
   }

   Texture MeneurImg;
   if (!MeneurImg.loadFromFile("Meneur.png"))
   {
      return EXIT_FAILURE;
   }


   srand(static_cast<unsigned int>(time(0)));


   for (int i = 0; i < NbSuiveux; i++)
   {
      Tab[i] = new CSuiveu(SuiveuImg, rand() % (Largeur),
         rand() % (Hauteur));
   }
   for (int i = NbSuiveux; i < NbOiseaux; i++)
   {
      Tab[i] = new CMeneur(MeneurImg, rand() % (Largeur),
         rand() % (Hauteur));
   }

   for (int i = 0; i < NbIterations; i++)
   {
      Fenetre.clear();
      Fenetre.draw(Fond);
      for (int i = 0; i < NbOiseaux; i++)
      {
         const COiseau* PlusProche =
            TrouverPlusProcheMeneur(Tab[i], Tab, NbOiseaux);
         Tab[i]->SeDeplacer(PlusProche);
         Tab[i]->Afficher(Fenetre);
      }
      Fenetre.display();
      sleep(milliseconds(10));
   }
   for (int i = 0; i < NbOiseaux; i++)
   {
      delete Tab[i];
   }
   return 0;
}